package com.qmth.jkserver.core.annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import com.qmth.jkserver.enums.TokenPolicy;

/**
 * 是否需要token校验
 * @author tianjun
 *
 */
@Target(ElementType.METHOD)
@Retention(RetentionPolicy.RUNTIME)
public @interface TokenValidate {

   TokenPolicy policy() default TokenPolicy.NEED;


}
