package com.qmth.jkserver.dao;

//import java.util.List;
//
//import org.springframework.data.mongodb.repository.MongoRepository;
//import org.springframework.stereotype.Repository;
//
//import com.qmth.jkserver.model.ExamRoomTemp;
//
//@Repository
//public interface ExamRoomTempDao extends MongoRepository<ExamRoomTemp, String> {
//
//	public List<ExamRoomTemp> findByExamCodeAndAttachmentId(String examCode,String attachmentId);
//
//}

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.qmth.jkserver.model.ExamRoomTemp;
import com.qmth.jkserver.model.ExamStudentTemp;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 考点考场临时表 Mapper 接口
 * </p>
 *
 * @author wangliang
 * @since 2023-03-01
 */
public interface ExamRoomTempDao extends BaseMapper<ExamRoomTemp> {

    public List<ExamRoomTemp> findByExamCodeAndAttachmentId(@Param("examCode") String examCode, @Param("attachmentId") Long attachmentId);

    @SuppressWarnings("MybatisXMapperMethodInspection")
    public List<Map> findByExamCodeAndAttachmentIdByMap(@Param("examCode") String examCode, @Param("attachmentId") Long attachmentId);

    @SuppressWarnings("MybatisXMapperMethodInspection")
    public List<Map> findByExamCodeAndAttachmentIdGroupByRoomCodeByMap(@Param("examCode") String examCode, @Param("attachmentId") Long attachmentId);

    public IPage<ExamRoomTemp> findByExamCode(IPage<Map> iPage,
                                                 @Param("examCode") String examCode,
                                                 @Param("attachmentId") Long attachmentId,
                                                 @Param("placeCode") String placeCode);
}