package com.qmth.jkserver.model;

//import java.io.Serializable;
//import java.util.Date;
//
//import org.springframework.data.annotation.Id;
//import org.springframework.data.mongodb.core.index.CompoundIndex;
//import org.springframework.data.mongodb.core.index.CompoundIndexes;
//import org.springframework.data.mongodb.core.index.Indexed;
//import org.springframework.data.mongodb.core.mapping.Document;
//import org.springframework.data.mongodb.core.mapping.Field;
//
///**
// * 考点考场临时表
// * @author tianjun
// *
// */
//
//@Document(collection = "jk_exam_room_temp")
//@CompoundIndexes({ @CompoundIndex(name = "exam_room_temp_idx", def = "{'exam_code': 1, 'attachment_id': 1}") })
//public class ExamRoomTemp implements Serializable {
//
//	/**
//	 *
//	 */
//	private static final long serialVersionUID = 7865645107596340752L;
//
//	@Id
//	private String id;
//
//	@Indexed
//	@Field("exam_code")
//	private String examCode;
//
//	//导入的考务文件的ID
//	@Field("attachment_id")
//	private String attachmentId;
//
//	@Field("place_code")
//	private String placeCode;
//
//	@Field("place_name")
//	private String placeName;
//
//	@Field("room_code")
//	private String roomCode;
//
//	@Field("room_name")
//	private String roomName;
//
//	@Field("jk_teacher")
//	private String jkTeacher;
//
//	@Field("jk_password")
//	private String jkPassword;
//
//	/**
//	 * 创建时间
//	 */
//	@Field("create_time")
//	private Date createTime;
//
//	/**
//	 * @return the createTime
//	 */
//	public Date getCreateTime() {
//		return createTime;
//	}
//
//	/**
//	 * @param createTime the createTime to set
//	 */
//	public void setCreateTime(Date createTime) {
//		this.createTime = createTime;
//	}
//
//	/**
//	 * @return the attachmentId
//	 */
//	public String getAttachmentId() {
//		return attachmentId;
//	}
//
//	/**
//	 * @param attachmentId the attachmentId to set
//	 */
//	public void setAttachmentId(String attachmentId) {
//		this.attachmentId = attachmentId;
//	}
//
//	/**
//	 * @return the examCode
//	 */
//	public String getExamCode() {
//		return examCode;
//	}
//
//	/**
//	 * @param examCode the examCode to set
//	 */
//	public void setExamCode(String examCode) {
//		this.examCode = examCode;
//	}
//
//	/**
//	 * @return the id
//	 */
//	public String getId() {
//		return id;
//	}
//
//	/**
//	 * @param id the id to set
//	 */
//	public void setId(String id) {
//		this.id = id;
//	}
//
//	/**
//	 * @return the placeCode
//	 */
//	public String getPlaceCode() {
//		return placeCode;
//	}
//
//	/**
//	 * @param placeCode the placeCode to set
//	 */
//	public void setPlaceCode(String placeCode) {
//		this.placeCode = placeCode;
//	}
//
//	/**
//	 * @return the placeName
//	 */
//	public String getPlaceName() {
//		return placeName;
//	}
//
//	/**
//	 * @param placeName the placeName to set
//	 */
//	public void setPlaceName(String placeName) {
//		this.placeName = placeName;
//	}
//
//	/**
//	 * @return the roomCode
//	 */
//	public String getRoomCode() {
//		return roomCode;
//	}
//
//	/**
//	 * @param roomCode the roomCode to set
//	 */
//	public void setRoomCode(String roomCode) {
//		this.roomCode = roomCode;
//	}
//
//	/**
//	 * @return the roomName
//	 */
//	public String getRoomName() {
//		return roomName;
//	}
//
//	/**
//	 * @param roomName the roomName to set
//	 */
//	public void setRoomName(String roomName) {
//		this.roomName = roomName;
//	}
//
//	/**
//	 * @return the jkTeacher
//	 */
//	public String getJkTeacher() {
//		return jkTeacher;
//	}
//
//	/**
//	 * @param jkTeacher the jkTeacher to set
//	 */
//	public void setJkTeacher(String jkTeacher) {
//		this.jkTeacher = jkTeacher;
//	}
//
//	/**
//	 * @return the jkPassword
//	 */
//	public String getJkPassword() {
//		return jkPassword;
//	}
//
//	/**
//	 * @param jkPassword the jkPassword to set
//	 */
//	public void setJkPassword(String jkPassword) {
//		this.jkPassword = jkPassword;
//	}
//}

import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;

/**
 * <p>
 * 考点考场临时表
 * </p>
 *
 * @author wangliang
 * @since 2023-03-01
 */
@ApiModel(value = "JkExamRoomTemp对象", description = "考点考场临时表")
@TableName("jk_exam_room_temp")
public class ExamRoomTemp implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "主键")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long id;

    @ApiModelProperty(value = "考试编码")
    private String examCode;

    @ApiModelProperty(value = "附件id")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long attachmentId;

    @ApiModelProperty(value = "地方编码")
    private String placeCode;

    @ApiModelProperty(value = "地方名称")
    private String placeName;

    @ApiModelProperty(value = "考场编码")
    private String roomCode;

    @ApiModelProperty(value = "考场名称")
    private String roomName;

    @ApiModelProperty(value = "监考老师")
    private String jkTeacher;

    @ApiModelProperty(value = "监考密码")
    private String jkPassword;

    @ApiModelProperty(value = "创建时间")
    private Long createTime;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getExamCode() {
        return examCode;
    }

    public void setExamCode(String examCode) {
        this.examCode = examCode;
    }

    public Long getAttachmentId() {
        return attachmentId;
    }

    public void setAttachmentId(Long attachmentId) {
        this.attachmentId = attachmentId;
    }

    public String getPlaceCode() {
        return placeCode;
    }

    public void setPlaceCode(String placeCode) {
        this.placeCode = placeCode;
    }

    public String getPlaceName() {
        return placeName;
    }

    public void setPlaceName(String placeName) {
        this.placeName = placeName;
    }

    public String getRoomCode() {
        return roomCode;
    }

    public void setRoomCode(String roomCode) {
        this.roomCode = roomCode;
    }

    public String getRoomName() {
        return roomName;
    }

    public void setRoomName(String roomName) {
        this.roomName = roomName;
    }

    public String getJkTeacher() {
        return jkTeacher;
    }

    public void setJkTeacher(String jkTeacher) {
        this.jkTeacher = jkTeacher;
    }

    public String getJkPassword() {
        return jkPassword;
    }

    public void setJkPassword(String jkPassword) {
        this.jkPassword = jkPassword;
    }

    public Long getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Long createTime) {
        this.createTime = createTime;
    }
}
